//---------------------------------------------------------------------------
//		ver.1.0		2004/03		author : Endou
//---------------------------------------------------------------------------
#ifdef		HAVE_CONFIG_H
#include	"config.h"
#endif
#include	"acpplib.h"
//---------------------------------------------------------------------------
set <string> gHeader;				//HTTP header stack
set <string> gHead;					//HTML header stack
string gBody;						//BODY tag strings
//---------------------------------------------------------------------------
void	set_header(const char *pStr)
//add HTTP header string to gHeader
//parameter		*pStr : header strings
//return		none
{
	if(pStr != NULL) gHeader.insert(pStr);
}
//---------------------------------------------------------------------------
void	set_head(const char *pStr)
//add HTML header string to gHead
//parameter		*pStr : head strings
//return		none
{
	if(pStr != NULL) gHead.insert(pStr);
}
//---------------------------------------------------------------------------
void	clear_header()
//clear gHeader
//parameter		none
//return		none
{
	gHeader.clear();
}
//---------------------------------------------------------------------------
void	clear_head()
//clear gHead
//parameter		none
//return		none
{
	gHead.clear();
}
//---------------------------------------------------------------------------
void	cout_header()
//send HTTP header. send data is gHeader.
//parameter		none
//return		none
{
	string	s;
	set <string> :: iterator it;
	static bool flag = false;		//send flag

	if(flag) return;				//allready send

	s = "Content-Type: text/html";	//default response header
	//search "Content-Type:"
	for(it=gHeader.begin();it!=gHeader.end();it++) {
		if(string::npos != it->find("Content-Type:")) {
			s = *it;
			gHeader.erase(it);
		}
	}

	cout << s << endl;				//send Content-Type: type
	for(it=gHeader.begin();it!=gHeader.end();it++) {
		cout << *it << endl;		//send other response header
	}
	cout << endl;					//send header-entity separator
	flag = true;
}
//---------------------------------------------------------------------------
void	cout_head()
//send HTML header. send data is gHead.
//parameter		none
//return		none
{
	string	a,b,c,d,e;
	set <string> :: iterator it;
	static bool flag = false;	//send flag

	if(flag) return;			//allready send
	cout_header();				//if dose not send HTTP header , send HTTP header

	//search "<!DOCTYPE" string
	a = "";
	for(it=gHead.begin();it!=gHead.end();it++) {
		if(string::npos != it->find("<!DOCTYPE")) {
			a = *it;
			gHead.erase(it);
		}
	}

	//search "<HTML" string
	b = "<HTML>";
	for(it=gHead.begin();it!=gHead.end();it++) {
		if(string::npos != it->find("<HTML")) {
			b = *it;
			gHead.erase(it);
		}
	}

	//search "<HEAD" string
	c = "<HEAD>";
	for(it=gHead.begin();it!=gHead.end();it++) {
		if(string::npos != it->find("<HEAD")) {
			c = *it;
			gHead.erase(it);
		}
	}

	//search "</HEAD" string
	d = "</HEAD>";
	for(it=gHead.begin();it!=gHead.end();it++) {
		if(string::npos != it->find("</HEAD")) {
			d = *it;
			gHead.erase(it);
		}
	}

	//search "<BODY" string
	e = "<BODY>";
	for(it=gHead.begin();it!=gHead.end();it++) {
		if(string::npos != it->find("<BODY")) {
			e = *it;
			gHead.erase(it);
		}
	}

	if(a != "") cout << a << endl;			//send <!DOCTYPE
	cout << b << endl;						//send <HTML>\n
	cout << c << endl;						//send <HEAD>\n
	for(it=gHead.begin();it!=gHead.end();it++) {
		cout << *it << endl;				//send other header
	}
	cout << d << endl;						//send </HEAD>\n
	cout << e << endl;						//send <BODY>\n

	flag = true;
}
//---------------------------------------------------------------------------
void	end_html()
//print </BODY>\n</HTML>\n
//parameter		none
//return		none
{
	static	bool	flag=false;

	if(flag) return;
	cout << "</BODY>\n</HTML>" << endl;
	flag = true;
}
//---------------------------------------------------------------------------
